#!/usr/bin/perl

<<DOC; 
S.Fleury
December 2000

               makeMatriceLinks-038.pl :


Format d'entre : 

- le programme prend en entre un corpus XML construit par webxref-038.

Format de sortie :

- le programme cree en sortie un tableau d'un certain nombre de lien (interne, externe (http,ftp), et mailto) rfrenc dans le corpus XML. 

DOC

#-------------------------------------------------------------------
sub GetParams {
 print "Getting parameters...\n";
 # Process parameters

 $InFile = "";
 while ($ARGV[0] =~ /^-/) {
   if    ($ARGV[0] eq "-help")     { &PrintHelp; }
   if    ($ARGV[0] eq "-h")        { &PrintHelp; }

   elsif ($ARGV[0] eq "-at")       { $AskedPath = &NextArg;
                                    $AskedPath = &shell_path($AskedPath); 

				 }
   else {&PrintUsage; exit;} 

   shift @ARGV;
}

}  # GetParams
#-------------------------------------------------------------------
sub shell_path {
  # Returns shell paths 
  local($dos_path) = @_;
  $dos_path =~ s/\\/\//g;
  return $dos_path;
}
#-------------------------------------------------------------------
sub get_path_to_results {
    # to add to the file name
    $path_to_results=$CWD;
    # default we put the results in the current working directory
    if ($AskedPath) {
	# a path_to_results asked
	$AskedPath .= '/' unless ($AskedPath =~ m#/$#);
				  # we make sure it ends with a slash
				  if ($AskedPath =~ m#^(?:\w:)?/#) {
				      # a full_path_to_results is asked
				      $path_to_results=$AskedPath;
				  }
				  else {
				      # the path asked is not a fullpath
				      $path_to_results .= "$AskedPath";
				      # we add it to the working directory
				  }
       }
}
#-------------------------------------------------------------------
sub PrintUsage {

 print <<"E_O_T";

Usage:          

Options:       -help/-h -at 


Configuring:   see the MAIN section

E_O_T
}
#-------------------------------------------------------------------
sub PrintHelp {

&PrintUsage;
}
#-------------------------------------------------------------------
sub NextArg {

  shift @ARGV;
  return $ARGV[0];

}  # NextArg
#-------------------------------------------------------------------
sub GetCWD {

  # -- GetCWD
  # Get the current working directory, make sure it ends with a slash
  # No parameters
  # Returns cwd
  # Modified by Calin MOSUT (the command `pwd` in the original code could not
  # reach the mount point on a Windows machine)

  use Cwd;
  local($dir);

  $dir = getcwd;
  # method from Cwd.pm
  $dir =~ s/\n//g;
  if ($dir !~ m#/$#) {
    $dir = "$dir/";
  }

  return $dir;

}  # GetCWD

sub by_count {
    $internal{$b} <=> $internal{$a}; 
}
sub by_count1 {
    $externalHttp{$b} <=> $externalHttp{$a}; 
}
sub by_count2 {
    $externalFtp{$b} <=> $externalFtp{$a}; 
}
sub by_count3 {
    $Internal{$b} <=> $Internal{$a}; 
}
sub by_count4 {
    $ExternalHttp{$b} <=> $ExternalHttp{$a}; 
}
sub by_count5 {
    $ExternalFtp{$b} <=> $ExternalFtp{$a}; 
}
sub by_count6 {
    $mailto{$b} <=> $mailto{$a}; 
}

sub by_count7 {
    $Mailto{$b} <=> $Mailto{$a}; 
}

sub by_count8 {
    $internalImage{$b} <=> $internalImage{$a}; 
}
sub by_count10 {
    $InternalImage{$b} <=> $InternalImage{$a}; 
}
sub by_count9 {
    $externalImage{$b} <=> $externalImage{$a}; 
}
sub by_count11 {
    $ExternalImage{$b} <=> $ExternalImage{$a}; 
}
sub by_count12 {
    $listeURLPajek{$a} <=> $listeURLPajek{$b};
}
sub by_count13 {
    $listeURL2Pajek{$b} <=> $listeURL2Pajek{$a};
}
sub by_count14 {
    $liste1URLPajek{$a} <=> $liste1URLPajek{$b};
}
sub by_count15 {
    $liste1URL2Pajek{$b} <=> $liste1URL2Pajek{$a};
}

#-------------------------------------------------------------------


&GetParams;
&get_path_to_results;

$CWD=&GetCWD;

print $ARGV[0],"\n";
print $path_to_results,"\n";

$CORPUSNAME="$ARGV[0]";


open(STATBYFILE, "$ARGV[0]") ;
open(TRACEF,">".$path_to_results."StatLinks.txt");
open(TRACEFF,">".$path_to_results."MatriceLinks.txt");
open(TRACEFFF,">".$path_to_results."MatriceLinksValue.txt");
open(TRACEFFFF,">".$path_to_results."MatriceLinksPajek.net");
open(TRACEFFFFF,">".$path_to_results."MatriceLinksPajek-accueil.net");

print TRACEFF "Site\tPage\tTypeInterne\tTokenInterne\tTypeExterne\tTokenExterne\tTypeMail\tTokenMail\tTypeFtp\tTokenFtp\tTypeIntImg\tTokenIntImg\tTypeExtImg\tTokenExtImg\n";


%listeURLPajek=();
%listeURL2Pajek=();
%liste1URLPajek=();
%liste1URL2Pajek=();
$pajekCpt=1;
$pajekCpt1=1;

while($line = <>) { 
    if ($line =~ /<SITEName>([^<]+)<\/SITEName>/) 
    { 
	$sitename=$1;
	$sitePcpt=$pajekCpt;
	if (!exists ( $listeURLPajek{$sitename})) {

	    $listeURLPajek{$sitename}=$pajekCpt;
	    $sitePcpt=$pajekCpt;
	    $pajekCpt++;
	    $listeURL2Pajek{$sitePcpt}=[];
	}

	%ExternalHttp=();
	%ExternalFtp=();
	%InternalImage=();
	%ExternalImage=();
	%Internal=();
	%Mailto=();
	@ValueLinksHttp=();
	print TRACEF "<SITE>\n";
	print TRACEF "<NAME>$sitename</NAME>\n";
	$line = <>;

	until ($line =~ /<\/SITE>/) 
	{ 
	    if ($line =~ /<SITEFile>/i) 
	    { 
		$line = <>;
		%externalHttp=();
		%externalFtp=();
		%internal=();
		%externalImage=();
		%internalImage=();
		%mailto=();
		if ($line =~ /<SITEFileName>([^<]+)<\/SITEFileName>/i) 
		{
		    $filename=$1;
		    if ($filename=~/index\.htm/i) {
			$sitePcpt1=$pajekCpt1;
			if (!exists ( $liste1URLPajek{$sitename})) {
			    
			    $liste1URLPajek{$sitename}=$pajekCpt1;
			    $sitePcpt1=$pajekCpt1;
			    $pajekCpt1++;
			    $liste1URL2Pajek{$sitePcpt1}=[];
			}
		    }
		}
		$line = <>;

		until ($line =~/<\/SITEFile>/){
		    if ($line =~ /<tagHTMLAttr TAG=\"A\" NUM=\"[0-9]+\" ATTRType=\"HREF\" VALUE=\"([^\"]+)\"\/>/i) 
		    {
			$typeLink=$1;
			$valueLink=$1;
			
#			print "TYPELINK: ",$typeLink," \n";
			if ($typeLink=~/http:\/\//i) {
			    $externalHttp{uc($typeLink)}++;
			    $ExternalHttp{uc($typeLink)}++;
			    push(@ValueLinksHttp,$valueLink);
			    
			    if (!exists ( $listeURLPajek{$valueLink})) {
				
				$listeURLPajek{$valueLink}=$pajekCpt;
				$pajekCpt++;
			    }
			    push(@{$listeURL2Pajek{$sitePcpt}}, $listeURLPajek{$valueLink});
			     if ($filename=~/index\.htm/) {
				 if (!exists ( $liste1URLPajek{$valueLink})) {
				     
				     $liste1URLPajek{$valueLink}=$pajekCpt1;
				     $pajekCpt1++;
				 }
				 push(@{$liste1URL2Pajek{$sitePcpt1}}, $liste1URLPajek{$valueLink});
			     }

			}

			if ($typeLink=~/ftp:\/\//i) {
			    $externalFtp{uc($typeLink)}++;
			    $ExternalFtp{uc($typeLink)}++;
			}
			if (($typeLink!~/ftp:\/\//i) && ($typeLink!~/http:\/\//i) && ($typeLink!~/mailto:/i)) {
			    $internal{uc($typeLink)}++;
			    $Internal{uc($typeLink)}++;
			}
			if ($typeLink=~/mailto:/i) {
			    $mailto{uc($typeLink)}++;
			    $Mailto{uc($typeLink)}++;
			}
		    }
		    if ($line =~ /<tagHTMLAttr TAG=\"IMG\" NUM=\"[0-9]+\" ATTRType=\"SRC\" VALUE=\"([^\"]+)\"\/>/i) 
		    {
			$typeLink=$1;
#			print $typeLink," \n";
			if ($typeLink=~/http:\/\//i) {
			    $externalImage{uc($typeLink)}++;
			    $ExternalImage{uc($typeLink)}++;
			}
			else {
			    $internalImage{uc($typeLink)}++;
			    $InternalImage{uc($typeLink)}++;
			}

			
		    }

		    $line=<>;
		}

		print TRACEF "<LINKSBYPAGE>\n";
#		print TRACEF "<PAGE NAME=\"$filename\">\n";
		print TRACEF "<PAGE>$filename</PAGE>\n";
		$tmpe=0;
		$tmpf=0;

		$tmpc=0;
		$tmpd=0;
		$internalLink = 0;
		$externalLink = 0;
		$internalImg = 0;
		$externalImg = 0;
		$mailLink = 0;
		$ftpLink = 0;
		$internalLink1 = 0;
		$externalLink1 = 0;
		$mailLink1 = 0;
		$ftpLink1 = 0;
		$internalImg1 = 0;
		$externalImg1 = 0;

		print TRACEF "<INTERNALLINK>\n";
		foreach $link (sort by_count keys %internal) {
			    $tmpc++;
			    $tmpd+=$internal{$link};
			    $tmpe++;
			    $tmpf+=$internal{$link};
			    print TRACEF "<LINK>$link</LINK><COUNT>$internal{$link}</COUNT>\n";
			}
	        print TRACEF "<TOTALLINKS>$tmpc</TOTALLINKS>\n";
		print TRACEF "<TOTALOCCUR>$tmpd</TOTALOCCUR>\n";
		print TRACEF "</INTERNALLINK>\n";
		$internalLink = $tmpc;
		$internalLink1 = $tmpd;
		
		$tmpc=0;
		$tmpd=0;
		print TRACEF "<EXTERNALHTTPLINK>\n";
		foreach $link (sort by_count1 keys %externalHttp) {
			    $tmpc++;
			    $tmpd+=$externalHttp{$link};
			    $tmpe++;
			    $tmpf+=$externalHttp{$link};
			    print TRACEF "<LINK>$link</LINK><COUNT>$externalHttp{$link}</COUNT>\n";
			}
	        print TRACEF "<TOTALLINKS>$tmpc</TOTALLINKS>\n";
		print TRACEF "<TOTALOCCUR>$tmpd</TOTALOCCUR>\n";
		print TRACEF "</EXTERNALHTTPLINK>\n";
		$externalLink = $tmpc;
		$externalLink1 = $tmpd;

		$tmpc=0;
		$tmpd=0;
		print TRACEF "<EXTERNALFTPLINK>\n";
		foreach $link (sort by_count2 keys %externalFtp) {
			    $tmpc++;
			    $tmpd+=$externalFtp{$link};
			    $tmpe++;
			    $tmpf+=$externalFtp{$link};
			    print TRACEF "<LINK>$link</LINK><COUNT>$externalFtp{$link}</COUNT>\n";
			}
	        print TRACEF "<TOTALLINKS>$tmpc</TOTALLINKS>\n";
		print TRACEF "<TOTALOCCUR>$tmpd</TOTALOCCUR>\n";
		print TRACEF "</EXTERNALFTPLINK>\n";
		$ftpLink = $tmpc;
		$ftpLink1 = $tmpd;

		$tmpc=0;
		$tmpd=0;
		print TRACEF "<MAILTOLINK>\n";
		foreach $link (sort by_count6 keys %mailto) {
			    $tmpc++;
			    $tmpd+=$mailto{$link};
			    $tmpe++;
			    $tmpf+=$mailto{$link};
			    print TRACEF "<LINK>$link</LINK><COUNT>$mailto{$link}</COUNT>\n";
			}
	        print TRACEF "<TOTALLINKS>$tmpc</TOTALLINKS>\n";
		print TRACEF "<TOTALOCCUR>$tmpd</TOTALOCCUR>\n";
		print TRACEF "</MAILTOLINK>\n";
		$mailLink = $tmpc;
		$mailLink1 = $tmpd;

		$tmpc=0;
		$tmpd=0;
		print TRACEF "<INTERNALIMAGE>\n";
		foreach $link (sort by_count8 keys %internalImage) {
			    $tmpc++;
			    $tmpd+=$internalImage{$link};
			    $tmpe++;
			    $tmpf+=$internalImage{$link};
			    print TRACEF "<LINK>$link</LINK><COUNT>$internalImage{$link}</COUNT>\n";
			}
	        print TRACEF "<TOTALLINKS>$tmpc</TOTALLINKS>\n";
		print TRACEF "<TOTALOCCUR>$tmpd</TOTALOCCUR>\n";
		print TRACEF "</INTERNALIMAGE>\n";
		$internalImg = $tmpc;
		$internalImg1 = $tmpd;
		$tmpc=0;
		$tmpd=0;
		print TRACEF "<EXTERNALIMAGE>\n";
		foreach $link (sort by_count9 keys %externalImage) {
			    $tmpc++;
			    $tmpd+=$externalImage{$link};
			    $tmpe++;
			    $tmpf+=$externalImage{$link};
			    print TRACEF "<LINK>$link</LINK><COUNT>$externalImage{$link}</COUNT>\n";
			}
	        print TRACEF "<TOTALLINKS>$tmpc</TOTALLINKS>\n";
		print TRACEF "<TOTALOCCUR>$tmpd</TOTALOCCUR>\n";
		print TRACEF "</EXTERNALIMAGE>\n";
		$externalImg = $tmpc;
		$externalImg1 = $tmpd;


		print TRACEF "<COUNTLINKBYPAGE>\n";
	        print TRACEF "<TOTALLINKS>$tmpe</TOTALLINKS>\n";
		print TRACEF "<TOTALOCCUR>$tmpf</TOTALOCCUR>\n";
		print TRACEF "</COUNTLINKBYPAGE>\n";

		print TRACEF "</LINKSBYPAGE>\n";

		print TRACEFF "$sitename\t$filename\t$internalLink\t$internalLink1\t$externalLink\t$externalLink1\t$mailLink\t$mailLink1\t$ftpLink\t$ftpLink1\t$internalImg\t$internalImg1\t$externalImg\t$externalImg1\n";


	    }

	    $line=<>;
	}

	print TRACEF "<LINKSBYSITE>\n";
	
	$tmpe=0;
	$tmpf=0;

	$tmpc=0;
	$tmpd=0;
	print TRACEF "<INTERNALLINK>\n";
	foreach $link (sort by_count3 keys %Internal) {
	    $tmpc++;
	    $tmpd+=$Internal{$link};
	    $tmpe++;
	    $tmpf+=$Internal{$link};
	    print TRACEF "<LINK>$link</LINK><COUNT>$Internal{$link}</COUNT>\n";
	}
	print TRACEF "<TOTALLINKS>$tmpc</TOTALLINKS>\n";
	print TRACEF "<TOTALOCCUR>$tmpd</TOTALOCCUR>\n";
	
	print TRACEF "</INTERNALLINK>\n";
	
	$tmpc=0;
	$tmpd=0;
	print TRACEF "<EXTERNALHTTPLINK>\n";
	foreach $link (sort by_count4 keys %ExternalHttp) {
	    $tmpc++;
	    $tmpd+=$ExternalHttp{$link};
	    $tmpe++;
	    $tmpf+=$ExternalHttp{$link};
	    print TRACEF "<LINK>$link</LINK><COUNT>$ExternalHttp{$link}</COUNT>\n";
	}
	print TRACEF "<TOTALLINKS>$tmpc</TOTALLINKS>\n";
	print TRACEF "<TOTALOCCUR>$tmpd</TOTALOCCUR>\n";
	print TRACEF "</EXTERNALHTTPLINK>\n";
	
	$tmpc=0;
	$tmpd=0;
	print TRACEF "<EXTERNALFTPLINK>\n";
	foreach $link (sort by_count5 keys %ExternalFtp) {
	    $tmpc++;
	    $tmpd+=$ExternalFtp{$link};
	    $tmpe++;
	    $tmpf+=$ExternalFtp{$link};
	    print TRACEF "<LINK>$link</LINK><COUNT>$ExternalFtp{$link}</COUNT>\n";
	}
	print TRACEF "<TOTALLINKS>$tmpc</TOTALLINKS>\n";
	print TRACEF "<TOTALOCCUR>$tmpd</TOTALOCCUR>\n";
	print TRACEF "</EXTERNALFTPLINK>\n";


	$tmpc=0;
	$tmpd=0;
	print TRACEF "<MAILTOLINK>\n";
	foreach $link (sort by_count7 keys %Mailto) {
	    $tmpc++;
	    $tmpd+=$Mailto{$link};
	    $tmpe++;
	    $tmpf+=$Mailto{$link};
	    print TRACEF "<LINK>$link</LINK><COUNT>$Mailto{$link}</COUNT>\n";
	}
	print TRACEF "<TOTALLINKS>$tmpc</TOTALLINKS>\n";
	print TRACEF "<TOTALOCCUR>$tmpd</TOTALOCCUR>\n";
	print TRACEF "</MAILTOLINK>\n";

	$tmpc=0;
	$tmpd=0;
	print TRACEF "<INTERNALIMAGE>\n";
	foreach $link (sort by_count10 keys %InternalImage) {
	    $tmpc++;
	    $tmpd+=$InternalImage{$link};
	    $tmpe++;
	    $tmpf+=$InternalImage{$link};
	    print TRACEF "<LINK>$link</LINK><COUNT>$InternalImage{$link}</COUNT>\n";
	}
	print TRACEF "<TOTALLINKS>$tmpc</TOTALLINKS>\n";
	print TRACEF "<TOTALOCCUR>$tmpd</TOTALOCCUR>\n";
	print TRACEF "</INTERNALIMAGE>\n";

	$tmpc=0;
	$tmpd=0;
	print TRACEF "<EXTERNALIMAGE>\n";
	foreach $link (sort by_count11 keys %ExternalImage) {
	    $tmpc++;
	    $tmpd+=$ExternalImage{$link};
	    $tmpe++;
	    $tmpf+=$ExternalImage{$link};
	    print TRACEF "<LINK>$link</LINK><COUNT>$ExternalImage{$link}</COUNT>\n";
	}
	print TRACEF "<TOTALLINKS>$tmpc</TOTALLINKS>\n";
	print TRACEF "<TOTALOCCUR>$tmpd</TOTALOCCUR>\n";
	print TRACEF "</EXTERNALIMAGE>\n";


	print TRACEF "<COUNTLINKBYSITE>\n";
	print TRACEF "<TOTALLINKS>$tmpe</TOTALLINKS>\n";
	print TRACEF "<TOTALOCCUR>$tmpf</TOTALOCCUR>\n";
	print TRACEF "</COUNTLINKBYSITE>\n";

	print TRACEF "</LINKSBYSITE>\n";
	print TRACEF "</SITE>\n";

	
	print TRACEFFF "<SITENAME=$sitename>\n";
	foreach $link (@ValueLinksHttp) {
	    print TRACEFFF "\t<LINK=$link>\n";
	}

	    




	}


    }



    print TRACEFFFF "\*Vertices     ",($pajekCpt-1),"\n";

foreach $link (sort by_count12 keys %listeURLPajek) {
    print TRACEFFFF "$listeURLPajek{$link} $link\n";
}

    print TRACEFFFF "\*Arcs\n";

foreach $link (sort by_count13 keys %listeURL2Pajek) {
    @tmp=@{$listeURL2Pajek{$link}};
    foreach $element (@tmp) {
	print TRACEFFFF "$link $element\n";
    }
}

    print TRACEFFFFF "\*Vertices     ",($pajekCpt1-1),"\n";

foreach $link (sort by_count14 keys %liste1URLPajek) {
    print TRACEFFFFF "$liste1URLPajek{$link} $link\n";
}

    print TRACEFFFFF "\*Arcs\n";

foreach $link (sort by_count15 keys %liste1URL2Pajek) {
    @tmp=@{$liste1URL2Pajek{$link}};
    foreach $element (@tmp) {
	print TRACEFFFFF "$link $element\n";
    }
}


close (STATBYFILE);


